	.dbfile C:\iccv7arm\MI533D~1\MIA7EC~1\MicroBoltPwmOutput.c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;          Delay -> R4
_main:
	.dbline -1
	.dbline 38
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBoltPwmOutput.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 4/2/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; 
; #include "MicroBoltPwmOutput.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void main(void)
;   {
	.dbline 46
; 
; /*
; |----------------------------------------------------
; |     MicroBolt hardware setup 
; |----------------------------------------------------
; */
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 48
; 
;   SCB_PLLCFG |= 0x23;				 	   		            // Turn on PLL, set to 59 MHz (0x03 is multiply value of 4)
	ldr R0,LIT_main+0
	ldr R1,[R0,#0]
	orr R1,R1,#35
	str R1,[R0,#0]
	.dbline 49
;   SCB_PLLCON |= 0x03;
	ldr R0,LIT_main+4
	ldr R1,[R0,#0]
	orr R1,R1,#3
	str R1,[R0,#0]
	.dbline 50
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy for PLL
	mov R0,#170
	ldr R1,LIT_main+8
	str R0,[R1,#0]
	.dbline 51
;   SCB_PLLFEED = 0x55; 
	mov R0,#85
	ldr R1,LIT_main+8
	str R0,[R1,#0]
	.dbline 53
; 
;   PCB_PINSEL0=0x00000000;                       // JTAG is via secondary port
	mov R0,#0
	ldr R1,LIT_main+12
	str R0,[R1,#0]
	.dbline 54
;   PCB_PINSEL1=0x55400000;
	ldr R0,LIT_main+16
	ldr R1,LIT_main+20
	str R0,[R1,#0]
	.dbline 55
;   GPIO_IODIR=(0x00000000<<16)|
	mov R0,#0
	ldr R1,LIT_main+24
	str R0,[R1,#0]
	.dbline 58
; 	     0x00000000;
;  
;   GPIO_IOCLR=0xffffffff;
	mvn R0,#0
	ldr R1,LIT_main+28
	str R0,[R1,#0]
	.dbline 59
;   GPIO_IOSET=(0x00000000<<16)| 
	mov R0,#0
	ldr R1,LIT_main+32
	str R0,[R1,#0]
	.dbline 62
;             0x00000000;  
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R0,LIT_main+24
	ldr R1,[R0,#0]
	orr R1,R1,#4194304
	str R1,[R0,#0]
	.dbline 64
; 
;   PCB_PINSEL0 |= P0_7_PWM_0_2;                  // Setup P0.7 to alternate function PWM0-2
	ldr R0,LIT_main+12
	ldr R1,[R0,#0]
	orr R1,R1,#32768
	str R1,[R0,#0]
	.dbline 64
	.dbline 66
; 
;   PWM_PR = 0x00000000;                          // Load prescaler  
	mov R0,#0
	ldr R1,LIT_main+36
	str R0,[R1,#0]
	.dbline 67
;   PWM_PCR = 0x00000400;                         // Select PWM2 as single edge and enable the PWM2 output
	mov R0,#1024
	ldr R1,LIT_main+40
	str R0,[R1,#0]
	.dbline 68
;   PWM_MCR =0x00000000;                          // PWM's are free running, no interrupt  
	mov R0,#0
	ldr R1,LIT_main+44
	str R0,[R1,#0]
	.dbline 70
; 
;   PWM_MR0 = 0x00000300;                         // Setup Match register 0 count       
	mov R0,#768
	ldr R1,LIT_main+48
	str R0,[R1,#0]
	.dbline 71
;   PWM_MR2 = 0x00000000;                         // Setup Match register 2 count
	mov R0,#0
	ldr R1,LIT_main+52
	str R0,[R1,#0]
	.dbline 73
;     
;   PWM_LER = 0x0000000F;                         // Enable shadow copy for match registers    
	mov R0,#15
	ldr R1,LIT_main+56
	str R0,[R1,#0]
	.dbline 74
;   PWM_TCR = 0x00000002;                         // Reset counter and prescaler            
	mov R0,#2
	ldr R1,LIT_main+60
	str R0,[R1,#0]
	.dbline 75
;   PWM_TCR = 0x00000009;                         // Enable PWM and counter
	mov R0,#9
	ldr R1,LIT_main+60
	str R0,[R1,#0]
	b L3
L2:
	.dbline 84
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
; 
;   while(1)                                      // Do this forever
;     {        
	.dbline 87
	mov R4,#0
	b L8
L5:
	.dbline 87
L6:
	.dbline 87
	add R4,R4,#1
L8:
	.dbline 87
;     unsigned int Delay;                      		  
; 
;     for (Delay = 0; Delay < 7750; Delay++);       // Delay for 10 mS  
	ldr R0,LIT_main+64
	cmp R4,R0
	blo L5
	.dbline 89
; 
;     PWM_MR2 = PWM_MR2 + 1;                      // Increment PWM2 match value
	ldr R0,LIT_main+52
	ldr R1,[R0,#0]
	add R1,R1,#1
	str R1,[R0,#0]
	.dbline 90
; 	  PWM_LER = 0x0000000F;                       // Latch new MR2 match value
	mov R0,#15
	ldr R1,LIT_main+56
	str R0,[R1,#0]
	.dbline 92
; 
;     if (PWM_MR2 >= PWM_MR0)                     // PWM match greater than or equal to PWM period?
	ldr R0,LIT_main+48
	ldr R0,[R0,#0]
	ldr R1,LIT_main+52
	ldr R1,[R1,#0]
	cmp R1,R0
	blo L9
	.dbline 93
;       {
	.dbline 94
;       PWM_MR2 = 0x00000000;                     // Reset match value to 0
	mov R0,#0
	ldr R1,LIT_main+52
	str R0,[R1,#0]
	.dbline 95
; 	    PWM_LER = 0x0000000F;                     // Latch new MR2 match value
	mov R0,#15
	ldr R1,LIT_main+56
	str R0,[R1,#0]
	.dbline 96
;       }  
L9:
	.dbline 97
L3:
	.dbline 83
	b L2
X0:
	.dbline -2
L1:
	mov R15,R14
	.dbline 0 ; func end
LIT_main:
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD -536707060
	DCD -536707068
	DCD -536788980
	DCD -536788916
	DCD -536788972
	DCD -536788968
	DCD -536788960
	DCD -536788912
	DCD -536788988
	DCD 7750
	.dbsym r Delay 4 i
	.dbend
	END
